// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Runner.pas' rev: 5.00

#ifndef RunnerHPP
#define RunnerHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ShellAPI.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Runner
{
//-- type declarations -------------------------------------------------------
typedef System::Comp LargeInt;

class DELPHICLASS ERunnerError;
class PASCALIMPLEMENTATION ERunnerError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall ERunnerError(const AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall ERunnerError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall ERunnerError(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall ERunnerError(int Ident, const System::TVarRec * Args
		, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall ERunnerError(const AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall ERunnerError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall ERunnerError(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall ERunnerError(System::PResStringRec ResStringRec, 
		const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~ERunnerError(void) { }
	#pragma option pop
	
};


struct TAppInfo
{
	AnsiString Name;
	unsigned Result;
	System::TDateTime Started;
	System::TDateTime Ended;
	System::Comp KernelTime;
	System::Comp UserTime;
} ;

class DELPHICLASS TWindowPosition;
class PASCALIMPLEMENTATION TWindowPosition : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FLeft;
	int FTop;
	int FWidth;
	int FHeight;
	void __fastcall SetLeft(int Value);
	void __fastcall SetTop(int Value);
	void __fastcall SetWidth(int Value);
	void __fastcall SetHeight(int Value);
	
public:
	__fastcall virtual TWindowPosition(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property int Left = {read=FLeft, write=SetLeft, nodefault};
	__property int Top = {read=FTop, write=SetTop, nodefault};
	__property int Width = {read=FWidth, write=SetWidth, nodefault};
	__property int Height = {read=FHeight, write=SetHeight, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TWindowPosition(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TWindowShowState { wssHide, wssNormal, wssShowMinimized, wssShowMaximized, wssShowNoActivate, wssShow, 
	wssMinimize, wssShowMinNoActive, wssShowNA, wssRestore, wssShowDefault };
#pragma option pop

class DELPHICLASS TWaitTerminateThread;
class DELPHICLASS TRunner;
#pragma option push -b-
enum TProcessPriority { ppIdle, ppNormal, ppHigh, ppRealTime };
#pragma option pop

typedef void __fastcall (__closure *TAppNotifyEvent)(const TAppInfo &App);

class PASCALIMPLEMENTATION TRunner : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FFileToRun;
	TProcessPriority FPriority;
	TAppNotifyEvent FOnAppTerminate;
	TAppNotifyEvent FOnAppIdle;
	Classes::TStringList* FEnvironment;
	TWindowPosition* FPosition;
	TWindowShowState FShowState;
	unsigned FProcessHandle;
	unsigned FThreadHandle;
	unsigned FProcessID;
	unsigned FThreadID;
	AnsiString FParameters;
	_STARTUPINFOA StartupInfo;
	_PROCESS_INFORMATION ProcessInfo;
	void __fastcall SetFileToRun(const AnsiString Value);
	void __fastcall SetPriority(const TProcessPriority Value);
	void __fastcall SetOnAppTerminate(const TAppNotifyEvent Value);
	void __fastcall SetOnAppIdle(const TAppNotifyEvent Value);
	void __fastcall SetEnvironment(const Classes::TStringList* Value);
	void __fastcall SetPosition(const TWindowPosition* Value);
	void __fastcall SetShowState(const TWindowShowState Value);
	void __fastcall SetParameters(const AnsiString Value);
	
public:
	__fastcall virtual TRunner(Classes::TComponent* AOwner);
	__fastcall virtual ~TRunner(void);
	void __fastcall Run(void);
	void __fastcall Stop(void);
	void __fastcall Terminate(void);
	bool __fastcall GetTimes(System::TDateTime &Started, System::Comp &KernelTime, System::Comp &UserTime
		);
	unsigned __fastcall GetHandle(void);
	__property unsigned ProcessHandle = {read=FProcessHandle, nodefault};
	__property unsigned ThreadHandle = {read=FThreadHandle, nodefault};
	__property unsigned ProcessID = {read=FProcessID, nodefault};
	__property unsigned ThreadID = {read=FThreadID, nodefault};
	
__published:
	__property AnsiString FileToRun = {read=FFileToRun, write=SetFileToRun};
	__property TProcessPriority Priority = {read=FPriority, write=SetPriority, nodefault};
	__property Classes::TStringList* Environment = {read=FEnvironment, write=SetEnvironment};
	__property TWindowPosition* Position = {read=FPosition, write=SetPosition};
	__property TWindowShowState ShowState = {read=FShowState, write=SetShowState, nodefault};
	__property AnsiString Parameters = {read=FParameters, write=SetParameters};
	__property TAppNotifyEvent OnAppTerminate = {read=FOnAppTerminate, write=SetOnAppTerminate};
	__property TAppNotifyEvent OnAppIdle = {read=FOnAppIdle, write=SetOnAppIdle};
};


class PASCALIMPLEMENTATION TWaitTerminateThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	unsigned FProcessHandle;
	unsigned FThreadHandle;
	TRunner* FRunner;
	TAppInfo FAppInfo;
	
protected:
	virtual void __fastcall Execute(void);
	void __fastcall SignalTermination(void);
	
public:
	__fastcall TWaitTerminateThread(unsigned AProcessHandle, unsigned AThreadHandle, TRunner* ARunner);
		
public:
	#pragma option push -w-inl
	/* TThread.Destroy */ inline __fastcall virtual ~TWaitTerminateThread(void) { }
	#pragma option pop
	
};


class DELPHICLASS TWaitIdleThread;
class PASCALIMPLEMENTATION TWaitIdleThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	unsigned FHandle;
	TRunner* FRunner;
	TAppInfo FAppInfo;
	
protected:
	virtual void __fastcall Execute(void);
	void __fastcall SignalIdle(void);
	
public:
	__fastcall TWaitIdleThread(unsigned AHandle, TRunner* ARunner);
public:
	#pragma option push -w-inl
	/* TThread.Destroy */ inline __fastcall virtual ~TWaitIdleThread(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Runner */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Runner;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Runner
